
import { _decorator, Component, Node, UIOpacity, tween, assetManager, Prefab, instantiate } from 'cc';
const { ccclass, property } = _decorator;

/**
 * Predefined variables
 * Name = testuiopacity
 * DateTime = Mon Jan 10 2022 17:30:11 GMT+0800 (中国标准时间)
 * Author = kearos
 * FileBasename = testuiopacity.ts
 * FileBasenameNoExtension = testuiopacity
 * URL = db://assets/uiopacity/testuiopacity.ts
 * ManualUrl = https://docs.cocos.com/creator/3.4/manual/zh/
 *
 */

@ccclass('testuiopacity')
export class testuiopacity extends Component {
    // [1]
    // dummy = '';

    // [2]
    // @property
    // serializableDummy = 0;
    @property(Prefab)
    res!: Prefab;
    @property(Node)
    test!: Node;

    start() {
        // [3]
    }

    // update (deltaTime: number) {
    //     // [4]
    // }
    onClick() {
        let node = this.test.getChildByPath('panel');
        if (!node) {
            node = instantiate(this.res)!;
            node.parent = this.test;
        }
        let cmp = node.getComponent(UIOpacity) || node.addComponent(UIOpacity);
        cmp.opacity = 0;
        tween(cmp).to(1, { opacity: 255 }).start();
    }

}

/**
 * [1] Class member could be defined like this.
 * [2] Use `property` decorator if your want the member to be serializable.
 * [3] Your initialization goes here.
 * [4] Your update function goes here.
 *
 * Learn more about scripting: https://docs.cocos.com/creator/3.4/manual/zh/scripting/
 * Learn more about CCClass: https://docs.cocos.com/creator/3.4/manual/zh/scripting/decorator.html
 * Learn more about life-cycle callbacks: https://docs.cocos.com/creator/3.4/manual/zh/scripting/life-cycle-callbacks.html
 */
